<template>
  <div>
    <h1>Todos</h1>
    <div class="todos">
      <div
        v-for="todo in allTodos"
        class="todo"
        :key="todo.id"
        @dblclick="onDblClick(todo)"
        v-bind:class="{'is-complete': todo.completed}"
      >
        {{todo.title}}
        <i class="fas fa-trash-alt" v-on:click="handleDeleteTodo($event, todo.id)" />
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
  name: "Todos",
  methods: {
    ...mapActions(["fetchTodos", "deleteTodo", "updateTodo"]),
    handleDeleteTodo(event, id) {
      this.deleteTodo(id);
    },
    onDblClick(todo) {
      const updTodo = {
        id: todo.id,
        title: todo.title,
        completed: !todo.completed
      };
      this.updateTodo(updTodo);
    }
  },
  computed: mapGetters(["allTodos"]),
  created() {
    this.fetchTodos();
  }
};
</script>

<style scoped>
.todos {
  display: grid;
  grid-template-columns: repeat(3, 1fr);
  grid-gap: 1rem;
}

.todo {
  border: 1px solid #ccc;
  background: #41b883;
  padding: 1rem;
  border-radius: 5px;
  text-align: center;
  position: relative;
  cursor: pointer;
}

i {
  position: absolute;
  bottom: 10px;
  right: 10px;
  color: black;
  cursor: pointer;
}

.is-complete {
  background: #35495e;
  color: #fff;
}
</style>